﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using InvokeSolutions.Xlsx.Data;
using InvokeSolutions.Xlsx;
using System.Diagnostics;
using System.Data;

namespace zSample.DataSources
{
    class CurrencyRate
    {
        public string Currency { get; set; }
        public decimal Rate { get; set; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            File.Copy("template.xlsx", "report.xlsx", true);

            var dds = new InvokeSolutions.Xlsx.Data.DocumentDataSource();

            dds["CUSTOMER"] = "Test Ltd.";
            dds["DATE"] = DateTime.Now.ToLongDateString();
            dds["INVOICE_NUMBER"] = "# INV-06-223";

            // anonymous classes
            dds["T"] = DataItem.ConvertFrom(
                    new[] {
                            new { INC = 1, Title = "Item #1", Ppi = 1.5,  Qty = 2 },
                            new { INC = 2, Title = "Item #4", Ppi = 4.5, Qty = 5 },
                            new { INC = 3, Title = "Item #7", Ppi = 15.0, Qty = 8 },
                            new { INC = 4, Title = "Item #10", Ppi = 150.0, Qty = 11 }
                    }
                );

            // own classes
            dds["R"] = DataItem.ConvertFrom(new[]{
                            new CurrencyRate { Currency = "USD", Rate = 0.70m },
                            new CurrencyRate { Currency = "EUR", Rate = 0.56m }
                    }
                );

            // DataTable
            
            /*
            DataTable table = new DataTable();

            table.Columns.Add("Currency", typeof(string));
            table.Columns.Add("Rate", typeof(decimal));

            table.Rows.Add("USD", 0.70m);
            table.Rows.Add("AUD", 0.75m);

            dds["R"] = table;*/

            /*dds["R"] =
                DataItem.ConvertFrom(
                    from rate in new[]{
                            new CurrencyRate { Currency = "USD", Rate = 0.70m },
                            new CurrencyRate { Currency = "EUR", Rate = 0.56m },
                            new CurrencyRate { Currency = "AUD", Rate = 0.75m }
                    }
                    where rate.Currency.EndsWith("D")
                    select new CurrencyRate
                    {
                        Currency = rate.Currency,
                        Rate = rate.Rate * 1.1m
                    }
                );*/

            /*TableDataItem table = new TableDataItem();

            DocumentDataSource usdRate = new DocumentDataSource();
            usdRate["Currency"] = "USD";
            usdRate["Rate"] = 0.70m;

            table.AddRow(usdRate);

            DocumentDataSource eurRate = new DocumentDataSource();
            eurRate["Currency"] = "EUR";
            eurRate["Rate"] = 0.56m;

            table.AddRow(eurRate);

            dds["R"] = table;*/

            /*dds = DocumentDataSource.ConvertFrom(
                    new
                    {
                        R = new[]{
                                new CurrencyRate { Currency = "USD", Rate = 0.70m },
                                new CurrencyRate { Currency = "EUR", Rate = 0.56m }
                            },
                        T =
                            new[] {
                                new { INC = 1, Title = "Item #1", Ppi = 1.5,  Qty = 2 },
                                new { INC = 2, Title = "Item #4", Ppi = 4.5, Qty = 5 },
                                new { INC = 3, Title = "Item #7", Ppi = 15.0, Qty = 8 },
                                new { INC = 4, Title = "Item #10", Ppi = 150.0, Qty = 11 }
                            },
                        Customer  ="Test Ltd",
                        Date = DateTime.Now.ToLongDateString(),
                        Invoice_Number = "# INV-06-223"
                    }
                );*/

            XlsxRenderer.RenderDocument("report.xlsx", dds);

            Process.Start("report.xlsx");
        }
    }
}
